#include "TMDlib.h"
//#include <fstream>
//#include <iomanip>
//#include <iostream>
//#include <sstream>
using namespace std;
using namespace TMDlib;

int nActiveSets = 0 ;
std::map<int, int> ActiveSet;
int iSet ;

TMD::TMD(void) {
   // cout << "TMD object is being created "  << endl;    
    }

extern "C" {   
  TMD TMDlibF[200];
    
//  void tmdinit_(const string name) {
//    TMDlibF.TMDinit(name) ;
//  };
  void tmdinit_(int & isetInput) { 
    int irep;
    int isetBase;
    nActiveSets = nActiveSets + 1;
    if ( isetInput >= 200000 && isetInput <= 510000 ) { irep = 0; isetBase = isetInput; }
    else if (isetInput == 101000 ) { irep = 0; isetBase = isetInput;  } 
    else if (isetInput >= 101201 && isetInput <= 101999  ) { irep = 0; isetBase = isetInput;  } 
    else if (isetInput >= 101010 && isetInput <= 101012  ) { irep = fmod(isetInput, 10); isetBase = isetInput - irep ; } 
    else if (isetInput >= 101020 && isetInput <= 101022  ) { irep = fmod(isetInput, 10); isetBase = isetInput - irep ; } 
    else if (isetInput == 101013 || isetInput == 101023  ) { irep = 0; isetBase = isetInput;  } 
    else if (isetInput == 102139 || isetInput == 102239  ) { irep = 0; isetBase = isetInput;  } 
    else if (isetInput >= 102140 && isetInput <= 102141  ) { irep = fmod(isetInput, 10)+1; isetBase = isetInput - irep  ;  } 
    else if (isetInput >= 102240 && isetInput <= 102241  ) { irep = fmod(isetInput, 10)+1; isetBase = isetInput - irep  ;  } 
    else if (isetInput == 10901300 || isetInput == 10901400) { irep = 0; isetBase = isetInput;  }
    else {
      irep = fmod(isetInput, 100);
      isetBase = isetInput - irep ;
    }
    int index =  nActiveSets;
    string name = TMDlibF[index].TMDstringPDF(isetBase) ;  
    /*
    cout << " fortran tmdinit " << isetInput << " " << isetBase<< " name = " << name << endl; 
    cout << " fortran tmdinit: irep = " << irep << endl; 
    cout << " fortran tmdinit: isetBase = " << isetBase << endl; 
    cout << " fortran tmdinit: nActiveSets = " << nActiveSets << " index = " << index << endl; 
    */
    if (irep == 0 ) {TMDlibF[index].TMDinit(name) ;}
    else {TMDlibF[index].TMDinit(name, irep) ;}
    // cout << " before TMDgetDesc " << endl;
    cout << "TMDSet Description: " << TMDlibF[index].TMDgetDesc() << endl;
    cout << "TMDSet Index: " << TMDlibF[index].TMDnumberPDF(name) << endl;
    cout << "TMDSet Extrapolation Q2: " << TMDlibF[index].TMDgetExtrapolation_Q2() << endl;
    ActiveSet[isetInput] = index ;
    iSet = index ; 
  };
  
  void tmdset_(int & isetInput) { 
  //cout << " tmdset: isetInput " << isetInput << endl;
  std::map<int,int>::iterator it;
  it = ActiveSet.find(isetInput);
  if (it != ActiveSet.end()) { 
     iSet = ActiveSet.find(isetInput)->second ;
     // cout << " TMDset find: " << ActiveSet.find(isetInput)->second << " iSet = " << iSet<< endl;
     }
  else { 
     cout << " TMDset find: no valid set found for isetInput = " << isetInput << endl;
     exit (EXIT_FAILURE); ;
     }
  };
  
  double tmdalphas_(double & mu) {
  double ret_val = TMDlibF[iSet].TMDalphas(mu);
  //cout << "tmdalphas = " << ret_val<< endl;
  return ret_val;
  }
  
  int tmdgetorderalphas_() {
  int ret_val = TMDlibF[iSet].TMDgetOrderAlphaS();
  //cout << " tmdgetorderalphas_ " << ret_val<< endl;
  return ret_val;
  }
  
  double tmdgetlam4_(){
  double ret_val= TMDlibF[iSet].TMDgetLam4();
  return ret_val;}
  
  int tmdgetorderpdf_(){
  int ret_val = TMDlibF[iSet].TMDgetOrderPDF();
  return ret_val;}
  
  double tmdgetxmin_() {
  
  double ret_val = TMDlibF[iSet].TMDgetXmin();
  return ret_val;}
  
  double tmdgetxmax_() {
  double ret_val = TMDlibF[iSet].TMDgetXmax();
  return ret_val;}
  
  double tmdgetq2min_() {
  double ret_val = TMDlibF[iSet].TMDgetQ2min();
  return ret_val;}
  
  double tmdgetq2max_() {
  double ret_val = TMDlibF[iSet].TMDgetQ2max();
  return ret_val;}
  
  int tmdgetnf_() {
  int ret_val = TMDlibF[iSet].TMDgetNf();
  return ret_val;}
  
  int tmdnumberpdf_(char *name){
  int ret_val = TMDlibF[iSet].TMDnumberPDF(name);
  return ret_val;}

  // TMDpdf 
  void tmdpdf_(int &kf, double &x, double &xbar, double &kt, double &mu, double& up, double& ubar,  
    double& dn, double& dbar,double& strange, double& sbar, double& charm, double& cbar, double& bottom, double& bbar, double& gluon) {

  TMDlibF[iSet].TMDpdf(x, xbar, kt, mu, up, ubar, dn, dbar, strange, sbar, charm, cbar, bottom, bbar, gluon);
  // cout << " tmdpdf_ " << uval << " " << dval << " " << gluon << endl;
  }   
  // TMDpdf 
  void tmdpdfset_(int &isetInput, int &kf, double &x, double &xbar, double &kt, double &mu, double& up, double& ubar,  
    double& dn, double& dbar,double& strange, double& sbar, double& charm, double& cbar, double& bottom, double& bbar, double& gluon) {

  std::map<int,int>::iterator it;
  it = ActiveSet.find(isetInput);
  if (it != ActiveSet.end()) { 
     iSet = ActiveSet.find(isetInput)->second ;
     // cout << " tmdpdfset_ find: " << ActiveSet.find(isetInput)->second << " iSet = " << iSet<< endl;
     }
  else { 
     cout << " tmdpdfset_ find: no valid set found for isetInput = " << isetInput << " EXIT_FAILURE " << endl;
     exit (EXIT_FAILURE); ;
     }

  TMDlibF[iSet].TMDpdf(x, xbar, kt, mu, up, ubar, dn, dbar, strange, sbar, charm, cbar, bottom, bbar, gluon);
  // cout << " tmdpdf_ " << uval << " " << dval << " " << gluon << endl;
  }   
}
